﻿using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamMultiColumnEdito_XamRibbon
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new MainWindowViewModel();
        }

        private void xamMultiColumnComboEditor1_DropDownOpened(object sender, EventArgs e)
        {
            // The border controls the size of the drop down
            Border border = GetXamMultiColumnComboEditorBorder(sender as XamMultiColumnComboEditor);

            Grid grid = border.Child as Grid;

            // Get child items panel
            MultiColumnComboItemsPanel gridItemsPanel = grid.Children[0] as MultiColumnComboItemsPanel;

            // Add Loaded event
            gridItemsPanel.Loaded -= gridItemsPanel_Loaded;
            gridItemsPanel.Loaded += gridItemsPanel_Loaded;
        }
        private void gridItemsPanel_Loaded(object sender, RoutedEventArgs e)
        {
            MultiColumnComboItemsPanel itemsPanel = sender as MultiColumnComboItemsPanel;
            itemsPanel.Measure(new Size(double.PositiveInfinity, double.PositiveInfinity));

            // Get the border and set the desired width
            Border border = GetXamMultiColumnComboEditorBorder(xamMultiColumnComboEditor1);
            border.MinWidth = itemsPanel.DesiredSize.Width + 5;	// +5 for extra padding
            border.MinHeight = 30;
        }

        private Border GetXamMultiColumnComboEditorBorder(XamMultiColumnComboEditor editor)
        {
            // Get Popup
            Popup popup = Utilities.GetDescendantFromType(editor as DependencyObject, typeof(Popup), true) as Popup;

            // Get Grid
            Grid grid = popup.Child as Grid;

            return grid.Children[0] as Border;

        }
    }

}